clear all
clc
echo on
% Example_04.m
% Solution to the problem posed in Example_04. It calculates the
% equilibrium concentration of the components of a system of two
% reversible chemical reactions using the Newtons method.
% Input data
echo off
c0 = input(' Vector of initial concentration of A, B, C, and D = ');
K1 = input(' 2A + B = C K1 = ');
K2 = input(' A + D = C K2 = ');
%Myfunc = input(' Name of the file containing the set of equations = ');
%Jacobian = input(' Name of the file containing the Jacobian = ');
disp('Function grafication')
x1=(0.1:0.01:0.5);
x2=(0.1:0.01:0.5);
[X1,X2]=meshgrid(x1,x2);
ca = c0(1) - 2*X1*c0(2) - X2*c0(4);
cb = (1 - X1)*c0(2);
cc = c0(3) + X1*c0(2) + X2*c0(4);
cd = (1 - X2)*c0(4);
Z1 = cc./(ca.^2)./cb - K1;
Z2 = cc./ca./cd - K2;
mesh(X1,X2,Z1);
hold on
mesh(X1,X2,Z2);
pause
disp('Zero Level Curves')
figure(2)
contour(X1,X2,Z1,[0 0]);
hold on
contour(X1,X2,Z2,[0 0]);
hold off
pause
disp('Root estimation')
[x1e,x2e] = ginput(1)
pause
repeat = 1;
while repeat
    x0 = input('\n\n Vector column of initial guesses = ');
    rho = input(' Relaxation factor = ');
    % Solution of the set of equations
    [solution,iter] = Newton(c0,K1,K2,rho,x0,1e-06);
    % Display the results
    x=solution
    fprintf('\n Results :\n x1 = %6.4f , x2 = %6.4f\n',x)
    fprintf('\n Solution reached after %3d iterations.\n\n',iter)
    repeat = input(' Repeat the calculations (0 / 1) ? ');
end